<?php
/**
 * Created by JetBrains PhpStorm.
 * User: victornovy
 * Date: 09/07/14
 * Time: 12:16
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\RetiradaEstoque;
use Estoque\Entities\Itlanctoest;
use Estoque\Entities\Lanctoestoq;
use Geral\Entities\Requesto;
use \Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Producao\Entities\Retiradaesto;
use Geral\Entities\Itrequesto;
use Estoque\Logic\AtualizacaoEstoque\AtualizadorDeEstoque;


class RetiradaEstoque {

    // Formata a data de forma que possa ser inserida no banco
    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDataDeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function insertRetiradasDeEstoque(
        $filial, $retirada, $lancamento, $data, $descricao, $setor, $centroCusto,
        $ordemProducao, $requisicao, $identificador,$operador, $dataInclusao, $dataAtualizacao, $organizacao,
        $organizacaoInclusao, $organizacaoAtualizacao, $operadorInclusao, $operadorAtualizacao, $ativo
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $lanctoestoq Lanctoestoq */
            $lanctoestoq = new Lanctoestoq();
            $lanctoestoq->setCdfilial($filial);
            $lanctoestoq->setNrlanctonf(NULL);
            $lanctoestoq->setNrlancestq($lancamento);
            $lanctoestoq->setIdtplancto($identificador);
            $lanctoestoq->setDtlancestq(self::formataData($data));
            $lanctoestoq->setDslancestq($descricao);
            $lanctoestoq->setIdaltcusmed(NULL);
            $lanctoestoq->setCdoperador($operador);
            $lanctoestoq->setIdentrsaidop(NULL);
            $lanctoestoq->setCdtipooper(NULL);
            $lanctoestoq->setNrprocprod(NULL);
            $lanctoestoq->setCdfilimovi($filial);
            $lanctoestoq->setCdalmoxarife(NULL);
            $lanctoestoq->setCdlocalestoq(NULL);
            $lanctoestoq->setNrtroca(NULL);
            $lanctoestoq->setNrorg($organizacao);
            $lanctoestoq->setDtinclusao(self::formataData($dataInclusao));
            $lanctoestoq->setDtultatu(self::formataData($dataAtualizacao));
            $lanctoestoq->setNrorginclusao($organizacaoInclusao);
            $lanctoestoq->setCdoperinclusao($operadorInclusao);
            $lanctoestoq->setNrorgultatu($organizacaoAtualizacao);
            $lanctoestoq->setCdoperultatu($operadorAtualizacao);
            $lanctoestoq->setIdstatusctbest('P');
            $lanctoestoq->persist();
            \Setforms2\Shared\Registry::getEntityManager()->flush();

            /** @var $retiradaesto Retiradaesto */
            $retiradaesto = new Retiradaesto();
            $retiradaesto->setCdfilial($filial);
            $retiradaesto->setNrretest($retirada);
            $retiradaesto->setDtretest(self::formataData($data));
            $retiradaesto->setDsretest(NULL);
            $retiradaesto->setCdfiliallan($filial);
            $retiradaesto->setNrlancestq($lancamento);
            $retiradaesto->setCdsetor($setor);
            $retiradaesto->setCdcentcust($centroCusto);
            $retiradaesto->setNrordprod($ordemProducao);
            $retiradaesto->setNrsubordprod(NULL);
            $retiradaesto->setCdetapaprod(NULL);
            $retiradaesto->setNrrequesto($requisicao);
            $retiradaesto->setIdpesprodret(NULL);
            $retiradaesto->setNrorg($organizacao);
            $retiradaesto->setDtinclusao(self::formataData($dataInclusao));
            $retiradaesto->setDtultatu(self::formataData($dataAtualizacao));
            $retiradaesto->setNrorginclusao($organizacaoInclusao);
            $retiradaesto->setCdoperinclusao($operadorInclusao);
            $retiradaesto->setNrorgultatu($organizacaoAtualizacao);
            $retiradaesto->setCdoperultatu($operadorAtualizacao);
            $retiradaesto->persist();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function insertItens(
        $filial, $lancamento, $sequencialItem, $produto, $descricao, $almoxarifado, $localEstoque,
        $lote, $subLote, $identificadorOrdem, $data, $identificadorEvolucao, $tipoRetirada, $centroCusto,
        $quantidadeLancada, $tipoMovimentacao, $quantidadeMovimentada, $valorUnitarioLancado,
        $valorTotalLancado, $quantidadeDevolvida, $valorUnitario, $valorUnitarioBruto, $requisicao,
        $dataInclusao, $dataAtualizacao, $organizacao, $organizacaoInclusao, $organizacaoAtualizacao,
        $operadorInclusao, $operadorAtualizacao, $produtoMovimentado
    )
    {
        try{
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $itlanctoest Itlanctoest */
            $itlanctoest = new Itlanctoest();
            $itlanctoest->setCdfilial($filial);
            $itlanctoest->setNrlancestq($lancamento);
            $itlanctoest->setNrsequitem($sequencialItem);
            $itlanctoest->setCdproduto($produto);
            $itlanctoest->setQtlanctoest($quantidadeMovimentada);
            $itlanctoest->setVrunilancto($valorUnitarioLancado);
            $itlanctoest->setVrtotlancto($valorTotalLancado);
            $itlanctoest->setIdtipomovi($tipoMovimentacao);
            $itlanctoest->setDtlancmovi(self::formataData($data));
            $itlanctoest->setIdordemclc($identificadorOrdem);
            $itlanctoest->setVrlanctoest($valorUnitario);
            $itlanctoest->setQttotlancto($quantidadeLancada);
            $itlanctoest->setVrlanctobrut($valorUnitarioBruto);
            $itlanctoest->setIdevolestoq($identificadorEvolucao);
            $itlanctoest->setDslancestit($descricao);
            $itlanctoest->setCdfilimovi($filial);
            $itlanctoest->setCdalmoxarife($almoxarifado);
            $itlanctoest->setCdlocalestoq($localEstoque);
            $itlanctoest->setNrloteestq($lote);
            $itlanctoest->setNrsublote($subLote);
            $itlanctoest->setCdcentcust($centroCusto);
            $itlanctoest->setCdtiporeti($tipoRetirada);
            $itlanctoest->setQtdevolestoq($quantidadeDevolvida);
            $itlanctoest->setNrorg($organizacao);
            $itlanctoest->setDtinclusao(self::formataData($dataInclusao));
            $itlanctoest->setDtultatu(self::formataData($dataAtualizacao));
            $itlanctoest->setNrorginclusao($organizacaoInclusao);
            $itlanctoest->setNrorgultatu($organizacaoAtualizacao);
            $itlanctoest->setCdoperinclusao($operadorInclusao);
            $itlanctoest->setCdoperultatu($operadorAtualizacao);
            $itlanctoest->setNrrequesto($requisicao);
            $itlanctoest->setCdprodmovi($produtoMovimentado);
            $itlanctoest->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateRetiradasDeEstoque(
        $filial, $retirada, $lancamento, $descricao, $setor, $centroCusto, $identificador,$operador,
        $tipoRetirada, $dataAtualizacao, $organizacaoAtualizacao, $operadorAtualizacao, $ativo,
        $organizacao
    )
    {
        /** @var $lanctoestoq Lanctoestoq */
        $lanctoestoq = Lanctoestoq::findOneByCdfilialAndNrlancestqAndIdtplanctoAndNrorg(
            $filial, $lancamento, $identificador, $organizacao
        );
        $lanctoestoq->setDslancestq($descricao);
        $lanctoestoq->setDtultatu(self::formataData($dataAtualizacao));
        $lanctoestoq->setCdoperultatu($operadorAtualizacao);
        $lanctoestoq->setNrorgultatu($organizacaoAtualizacao);
        $lanctoestoq->persist();

        /** @var $retiradaesto Retiradaesto */
        $retiradaesto = Retiradaesto::findOneByCdfilialAndNrretestAndNrlancestqAndNrorg(
            $filial, $retirada, $lancamento, $organizacao
        );
        $retiradaesto->setCdsetor($setor);
        $retiradaesto->setCdcentcust($centroCusto);
        $retiradaesto->setDtultatu(self::formataData($dataAtualizacao));
        $retiradaesto->setCdoperultatu($operadorAtualizacao);
        $retiradaesto->setNrorgultatu($organizacaoAtualizacao);
        $retiradaesto->persist();

        /** @var $itlanctoest Itlanctoest */
        $itlanctoest = Itlanctoest::findByCdfilialAndNrlancestqAndNrorg($filial, $lancamento, $organizacao);
        foreach ($itlanctoest as $item) {
            $item->setCdtiporeti($tipoRetirada);
            $item->persist();
        }
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function updateItens(
        $filial, $lancamento, $produto, $quantidadeLancada, $quantidadeMovimentada,
        $quantidadeDevolvida, $valorUnitarioBruto, $valorUnitario, $valorTotalLancado, $organizacao,
        $valorUnitarioLancado, $dataAtualizacao, $organizacaoAtualizacao, $operadorAtualizacao,
        $requisicao, $almoxarifado, $localEstoque, $lote, $subLote
    )
    {
        try{
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $itens Itlanctoest */
            $itens = Itlanctoest::findOneByCdfilialAndCdprodutoAndNrlancestqAndNrorg(
                $filial, $produto, $lancamento, $organizacao
            );
            if ($requisicao) {
                $itens->setCdalmoxarife($almoxarifado);
                $itens->setCdlocalestoq($localEstoque);
                $itens->setNrloteestq($lote);
                $itens->setNrsublote($subLote);
            }
            $itens->setQttotlancto($quantidadeLancada);
            $itens->setQtdevolestoq($quantidadeDevolvida);
            $itens->setQtlanctoest($quantidadeMovimentada);
            $itens->setVrunilancto($valorUnitarioLancado);
            $itens->setVrtotlancto($valorTotalLancado);
            $itens->setVrlanctoest($valorUnitario);
            $itens->setVrlanctobrut($valorUnitarioBruto);
            $itens->setDtultatu(self::formataData($dataAtualizacao));
            $itens->setNrorgultatu($organizacaoAtualizacao);
            $itens->setCdoperultatu($operadorAtualizacao);

            $itens->persist();
            $connection->flush();
            $connection->commit();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function deleteRetiradaDeEstoque($filial, $retirada, $lancamento, $identificador)
    {
        /** @var $retiradaesto Retiradaesto */
        $retiradaesto = Retiradaesto::findOneByCdfilialAndNrretestAndNrlancestq(
            $filial, $retirada, $lancamento
        );
        $retiradaesto->delete();

        /** @var $lanctoestoq Lanctoestoq */
        $lanctoestoq = Lanctoestoq::findOneByCdfilialAndNrlancestqAndIdtplancto(
            $filial, $lancamento, $identificador
        );
        $lanctoestoq->delete();

        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function deleteItensRetirada(
        $filial, $retirada, $lancamento, $requisicao, $produto, $sequencialItem, $organizacao, $todos
    )
    {
        /** @var $itens Itlanctoest */
        if ($todos == 'N') {
            self::updateItensRequisicao(
                $filial, 'A', $requisicao, '', $produto, '', $organizacao, ''
            );
            $itens = Itlanctoest::findOneByCdfilialAndNrlancestqAndCdprodutoAndNrsequitemAndNrorg(
                $filial, $lancamento, $produto, $sequencialItem, $organizacao
            );
            if ($itens)
                $itens->delete();
        } else {
            $itens = Itlanctoest::findByCdfilialAndNrlancestqAndNrorg(
                $filial, $lancamento, $organizacao
            );
            if ($itens) {
                /** @var $item Itlanctoest */
                foreach ($itens as $item) {
                    self::updateItensRequisicao(
                        $item->getCdfilial(), 'A', $item->getNrrequesto(), '', $item->getCdproduto(),
                        '', $item->getNrorg(), ''
                    );
                    $item->delete();
                }
            }
            self::atualizaEstoqueRetirada($filial, $lancamento, $organizacao);
            self::deleteRetiradaDeEstoque($filial, $retirada, $lancamento, '3');
        }
        self::updateRequisicao($filial, $requisicao, $organizacao);
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function atualizaEstoqueRetirada($filial, $lancamento, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $objLancto Lanctoestoq */
            $objLancto = Lanctoestoq::consultaLancamento($organizacao, $filial, $lancamento);

            /** @var $objItens Itlanctoest */
            $objItens = Itlanctoest::consultaItens($filial, $lancamento, $organizacao);
            if ($objItens) {
                /** @var $item Itlanctoest */
                foreach($objItens as $item) {
                    AtualizadorDeEstoque::atualizarEstoque($objLancto, $item);
                }
            } else {
                AtualizadorDeEstoque::atualizarEstoque($objLancto);
            }

            $connection->flush();
            $connection->commit();
        } catch(\Exception $e){
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateItensRequisicao(
        $filial, $situacao, $requisicao, $lancamento, $produto, $sequencialItem, $organizacao, $filialLanc
    )
    {
        try {
            /** @var $itensRequisicao Itrequesto */
            $itensRequisicao = Itrequesto::findOneByCdfilialAndNrrequestoAndCdprodutoAndNrorg(
                $filial, $requisicao, $produto, $organizacao
            );
            if ($itensRequisicao) {
                $itensRequisicao->setIdstitrequ($situacao);
                $itensRequisicao->setCdfililanc($filialLanc);
                $itensRequisicao->setNrlancestq($lancamento);
                $itensRequisicao->setNrsequitem($sequencialItem);
                $itensRequisicao->persist();
            }
            \SetForms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateRequisicao($filial, $requisicao, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $requesto Requesto */
            $requesto = Requesto::findOneByCdfilialAndNrrequestoAndNrorg($filial, $requisicao, $organizacao);
            $situacao = count(Itrequesto::getRepository()->consultaSituacaoRequisicao($filial, $requisicao, $organizacao));

            if ($situacao > 1)
                $situacao = 'P';
            elseif ($situacao == 1)
                $situacao = 'E';
            else
                $situacao = 'A';
            if ($requesto) {
                $requesto->setCdfillancreqc(NULL);
                $requesto->setNrlancreqc(NULL);
                $requesto->setIdstatusreq($situacao);

                $requesto->persist();
            }
            $connection->flush();
            $connection->commit();
            \SetForms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }
}