/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Rotina de exportao das pessoas jurdicas

Criao:
28/03/2013 - Fabrcio Marcelo

@C:\web_545\sql\end_conv\oracle\clientes\ris\6420_RISSTPO_Exporta_Pessoa_Juridica_Saga.SQL
*/

CREATE OR REPLACE PROCEDURE EXPORTA_PESSOA_JURIDICA_SAGA
AS
   V_NRCONTADOR   INT;
BEGIN
   V_NRCONTADOR := 0;

   /* Novos registros e Registros alterados */
   FOR C_PSJ IN (SELECT F.CDFORNECED AS CHAVE, 'F' AS ID, F.NRINSJURFORN AS NRINSJUR, F.NMRAZSOCFORN AS NMRAZAOSOC, F.NMFANTFORN AS NMFANTASIA, E.NRCEPFORN AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFORN AS NMBAIRRO,
                        E.DSENDEFORN AS DSENDERECO, 10 AS CODNATPSS
                   FROM FORNECEDOR F, ENDEFORN E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURFORN = 'J'
                    AND F.DTEXPFORNSAGA IS NULL
                    AND E.CDFORNECED = F.CDFORNECED
                    AND E.IDTPENDEFORN = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDCLIENTE AS CHAVE, 'C' AS ID, F.NRINSJURCLIE AS NRINSJUR, F.NMRAZSOCCLIE AS NMRAZAOSOC, F.NMFANTCLIE AS NMFANTASIA, E.NRCEPCLIE AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRCLIE AS NMBAIRRO,
                        E.DSENDECLIE AS DSENDERECO, 9 AS CODNATPSS
                   FROM CLIENTE F, ENDECLIE E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURCLIE = 'J'
                    AND F.DTEXPCLIESAGA IS NULL
                    AND E.CDCLIENTE = F.CDCLIENTE
                    AND E.IDTPENDECLIE = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                        E.DSENDEFILI AS DSENDERECO, 9 AS CODNATPSS
                   FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.DTEXPFILISAGA IS NULL
                    AND E.CDFILIAL = F.CDFILIAL
                    AND E.IDTPENDEFILI = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                        E.DSENDEFILI AS DSENDERECO, 12 AS CODNATPSS
                   FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.DTEXPFILISAGA IS NULL
                    AND E.CDFILIAL = F.CDFILIAL
                    AND E.IDTPENDEFILI = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.IDTPIJURTRAN AS CHAVE, 'T' AS ID, F.NRINSJURTRAN AS NRINSJUR, F.NMRAZSOCTRAN AS NMRAZAOSOC, F.NMFANTTRAN AS NMFANTASIA, F.NRCEPTRAN AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, F.NMBAIRTRAN AS NMBAIRRO,
                        F.DSENDETRAN AS DSENDERECO, 12 AS CODNATPSS
                   FROM TRANSPORT F, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURTRAN = 'J'
                    AND F.DTEXPTRANSSAGA IS NULL
                    AND P.CDPAIS = F.CDPAIS
                    AND ES.CDPAIS = F.CDPAIS
                    AND ES.SGESTADO = F.SGESTADO
                    AND M.CDPAIS = F.CDPAIS
                    AND M.SGESTADO = F.SGESTADO
                    AND M.CDMUNICIPIO = F.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDFORNECED AS CHAVE, 'F' AS ID, F.NRINSJURFORN AS NRINSJUR, F.NMRAZSOCFORN AS NMRAZAOSOC, F.NMFANTFORN AS NMFANTASIA, E.NRCEPFORN AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFORN AS NMBAIRRO,
                        E.DSENDEFORN AS DSENDERECO, 10 AS CODNATPSS
                   FROM FORNECEDOR F, ENDEFORN E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURFORN = 'J'
                    AND E.CDFORNECED = F.CDFORNECED
                    AND E.IDTPENDEFORN = 'P'
                    AND ((F.DTULTATUFORN >= F.DTEXPFORNSAGA) OR (E.DTULTATUENFO >= F.DTEXPFORNSAGA))
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDCLIENTE AS CHAVE, 'C' AS ID, F.NRINSJURCLIE AS NRINSJUR, F.NMRAZSOCCLIE AS NMRAZAOSOC, F.NMFANTCLIE AS NMFANTASIA, E.NRCEPCLIE AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRCLIE AS NMBAIRRO,
                        E.DSENDECLIE AS DSENDERECO, 9 AS CODNATPSS
                   FROM CLIENTE F, ENDECLIE E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURCLIE = 'J'
                    AND E.CDCLIENTE = F.CDCLIENTE
                    AND E.IDTPENDECLIE = 'P'
                    AND ((F.DTULTATUCLIE >= F.DTEXPCLIESAGA) OR (E.DTULTATUECLI >= F.DTEXPCLIESAGA))
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                        E.DSENDEFILI AS DSENDERECO, 9 AS CODNATPSS
                   FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE ((F.DTULTATUFILI >= F.DTEXPFILISAGA) OR (E.DTULTATUEFIL >= F.DTEXPFILISAGA))
                    AND E.CDFILIAL = F.CDFILIAL
                    AND E.IDTPENDEFILI = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                        E.DSENDEFILI AS DSENDERECO, 12 AS CODNATPSS
                   FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE ((F.DTULTATUFILI >= F.DTEXPFILISAGA) OR (E.DTULTATUEFIL >= F.DTEXPFILISAGA))
                    AND E.CDFILIAL = F.CDFILIAL
                    AND E.IDTPENDEFILI = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT F.IDTPIJURTRAN AS CHAVE, 'T' AS ID, F.NRINSJURTRAN AS NRINSJUR, F.NMRAZSOCTRAN AS NMRAZAOSOC, F.NMFANTTRAN AS NMFANTASIA, F.NRCEPTRAN AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, F.NMBAIRTRAN AS NMBAIRRO,
                        F.DSENDETRAN AS DSENDERECO, 12 AS CODNATPSS
                   FROM TRANSPORT F, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURTRAN = 'J'
                    AND F.DTULTATUTRAN >= F.DTEXPTRANSSAGA
                    AND P.CDPAIS = F.CDPAIS
                    AND ES.CDPAIS = F.CDPAIS
                    AND ES.SGESTADO = F.SGESTADO
                    AND M.CDPAIS = F.CDPAIS
                    AND M.SGESTADO = F.SGESTADO
                    AND M.CDMUNICIPIO = F.CDMUNICIPIO)
   LOOP
      INSERT INTO INT_CADPSJ
         (CODPSS, NOMPSS, NOMAPEPSS, CODSITPSJ, DATCAD, DATHORBLQ,
          CODMTV, NOMEML, NOMWEBSIT, NUMCEL1, NUMCEL2, NUMFAX,
          NUMIDPSSPRM, NUMIDPSSSCG, NUMTEL1, NUMTEL2, CODNATPSS, CODPPSEXT,
          BOLPDRCRP, CEP, CODTIPENDPTL, NOMPAI, NOMUFE, NOMLOC,
          NOMBRO, NOMRUA, NUMCMP, NOMCMP, FLAPRC, DSCERR, DATULTPRC)
      VALUES
         (C_PSJ.NRINSJUR, C_PSJ.NMRAZAOSOC, C_PSJ.NMFANTASIA, 1, SYSDATE, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, C_PSJ.CODNATPSS, NULL,
          1, C_PSJ.CEP, 1, C_PSJ.NMPAIS, C_PSJ.NMESTADO, C_PSJ.NMMUNICIPIO,
          C_PSJ.NMBAIRRO, C_PSJ.DSENDERECO, NULL, NULL, '0', NULL, NULL);

      V_NRCONTADOR := V_NRCONTADOR + 1;

      /* Relacionamento da pessoa juridica com a filial */
      FOR C_FILIAL IN (SELECT DISTINCT CDFILIALSAGA FROM PARAMFILIAL
                        WHERE NOT CDFILIALSAGA IS NULL)
      LOOP
         INSERT INTO INT_CADACSPSS
            (CODSTE, CODTRN, CODPSS, FLAPRC, DSCERR, DATULTPRC)
         VALUES
            (C_FILIAL.CDFILIALSAGA, 0, C_PSJ.NRINSJUR, '0', NULL, NULL);

         V_NRCONTADOR := V_NRCONTADOR + 1;
      END LOOP;

      IF C_PSJ.ID = 'F' THEN
         UPDATE FORNECEDOR
            SET DTEXPFORNSAGA = SYSDATE
          WHERE CDFORNECED = C_PSJ.CHAVE;
      ELSE
         IF C_PSJ.ID = 'C' THEN
            UPDATE CLIENTE
               SET DTEXPCLIESAGA = SYSDATE
             WHERE CDCLIENTE = C_PSJ.CHAVE;
         ELSE
            IF C_PSJ.ID = 'L' THEN
               UPDATE FILIAL
                  SET DTEXPFILISAGA = SYSDATE
                WHERE CDFILIAL = C_PSJ.CHAVE;
            ELSE
               UPDATE TRANSPORT
                  SET DTEXPTRANSSAGA = SYSDATE
                WHERE IDTPIJURTRAN = C_PSJ.CHAVE
                  AND NRINSJURTRAN = C_PSJ.NRINSJUR;
            END IF;
         END IF;
      END IF;

      V_NRCONTADOR := V_NRCONTADOR + 1;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_PESSOA_JURIDICA_SAGA','5.45.XXX'); END;
/

